
<!DOCTYPE HTML>
<html>
  <head>

    <title>DashGL.com</title>

    <meta charset="utf-8" />
    <meta name="viewport"
      content="width=device-width,initial-scale=1.0,user-scalable=no">
    <meta name="description" content="Tutortials for Linux programming using
      GTK, C, and OpenGL" />
    <meta name="keywords" content="Linux,C,OpenGL,Tutorial,GTK">
    <meta name="author" content="Kion">

    <link rel="shortcut icon" href="/img/favicon.png">
    <link rel="stylesheet" type="text/css" href="/css/layout.css" />
  </head>
  <body>

    <div class="title">
      <a href="/Information?file=Mascot"><img
          src="/img/others_20171117_dashgl_dash_cropped_icon.png" /></a>
    </div>

    <header>

      <table>
        <th>
          <h1><a href="index.php">DashGL</a></h1>
        </th>
        <td></td>

        <td><a href='/Brickout'>Brickout</a></td>
        <td><a href='/Invaders'>Invaders</a></td>
        <td><a href='/Astroids'>Astroids</a></td>
        <td><a href='/Information' class='selected'>Information</a></td>
      </table>
    </header>

    <nav id="nav">

      <li><a href='/Brickout'>Brickout</a></li>
      <li><a href='/Invaders'>Invaders</a></li>
      <li><a href='/Astroids'>Astroids</a></li>
      <li><a href='/Information' class='selected'>Information</a></li>
    </nav>

    <section>

      <article>

        <p>
          OpenGL is a library for sending instructions to the GPU.
          DashGL is a small library for managing Vectors and Matrices
          to pass into OpenGL. To create an OpenGL context, you will
          need a window library to open a window and start an OpenGL
          context. I have tried a few of them, these are my thought.
          <p>


            <h3>Freeglut</h3>

            <p>
              Freeglut is quick and effective. It's a very small window library
              that provided a few very basic functionality for giving
              you a window and getting into an OpenGL context. If you
              are on the Raspberry Pi, or just want somewhere to get started
              with OpenGL then this is a good library to go with.
            </p>

            <h3>glfw</h3>

            <p>
              Glfw is the window library currently used in the OpenGL
              red book. It's a simple library, similar to Freeglut with
              a few more controls on window hints. There are a lot of
              resources to work with between their site and RedBook
              examples on OpenGL. While the library is written in C
              a lot of the examples are written in C++ and use GLM. One
              note is that depending on your environment, this is not
              the easiest library to compile and run.
            </p>

            <h3>SDL</h3>

            <p>
              SDL is definitely one of the most seductive and compelling
              libraries out there. It's a full fledged library which
              includes api's for audio, video, controls and the library
              is supported to cross compile to a lot of different platforms.
              It's also easy to install the tools required to compile
              and run programs in it. The downside is that for the wide
              adoption of emulators and games that use SDL, I can't for
              the life of me find any resources in C or Linux to figure out
              how to get a handle on this library.
            </p>

            <h3>GTK</h3>

            <p>
              GTK is the standard this site uses. The most difficult part
              is figuring out the syntax for creating and looping a GTKGLArea,
              but once you get the basics down, it's a pretty versitile
              toolkit to work with with a lot of options for expansion. The XML
              and approach for layouts is kind of confusing if you want to
              branch
              out, but in terms of creating applications in C, on Linux, you'd
              be
              hard pressed to find better tools than this.
            </p>

            <h2>Math Libraries</h2>

            <h3>Mathc</h3>

            <p>
              <a href="https://github.com/ferreiradaselva/mathc">Link</a> -
              The "Dash Graphics Library" is still very much a work in progress
              as I'm only added in new functions instead of just throwing a
              bunch of matrix and quaternion methods in that I don't know are
              working correctly or not. If you want a fully featured linear math
              library in C now, then mathc is the way to go. It offers and
              extremely
              full featured set of functions that's pretty much everything I
              want
              to have in DashGL.
            </p>

            <h3>Linmath</h3>

            <p>
              <a href="https://github.com/datenwolf/linmath.h">Link</a> -
              Linmath is another option for a matrix and vector math library.
              It's a tiny
              library that uses macros inside a single header file to cover most
              of the
              math mathmatical functions you could want.
            </p>

            <h2>Shader Libraries</h2>

            <h3>SOIL</h3>

            <p>
              <a href="http://www.lonesock.net/soil.html">Link</a> -
              SOIL is the the "Simple OpenGL Image Library". Right now DashGL
              only offers a single
              function for loading a small subset of png encoded images. If you
              want or need a
              more complete library for managing textures with OpenGL in C then
              this is probably
              the library to use.
            </p>

          </article>

        </section>

        <aside>
          <ul>

            <li><a href='/Information/About'>About</a></li>
            <li><a href='/Information/Contribute'>Contribute</a></li>
            <li><a class='selected' href='/Information/Libraries'>Libraries</a></li>
            <li><a href='/Information/OpenGL_Resources'>OpenGL
                Resources</a></li>
            <li><a href='/Information/GTK_Resources'>GTK Resources</a></li>
            <li><a href='/Information/Copyright'>Copyright</a></li>
            <li><a href='/Information/Mascot'>Mascot</a></li>
            <li><a href='/Information/Raspberry_Pi'>Raspberry Pi</a></li>
          </ul>
        </aside>

        <footer>

          <table>
            <tr>
              <td><a href='/Information/Contribute'>&lt;&lt; Prev<br>Contribute</a></td><td></td><td><a
                  href='/Information/OpenGL_Resources'>Next &gt;&gt;<br>OpenGL
                  Resources</a></td> </tr>
          </table>

          Copyright &copy; 2017 DashGL Project

        </footer>

      </body>

    </html>
